DROP DATABASE IF EXISTS SAEQUIZZ;
CREATE DATABASE SAEQUIZZ;
USE SAEQUIZZ;
DROP TABLE IF EXISTS REPONSEUSER;
DROP TABLE IF EXISTS REPONSEQUESTION;
DROP TABLE IF EXISTS QUESTION;
DROP TABLE IF EXISTS TYPEQUESTION;
DROP TABLE IF EXISTS QUESTIONNAIRE;
DROP TABLE IF EXISTS USER;

CREATE TABLE USER(
    ID INT NOT NULL PRIMARY KEY AUTO_INCREMENT,
    EMAIL VARCHAR(50) NOT NULL UNIQUE,
    MOTDEPASSE VARCHAR(50) NOT NULL
);

CREATE TABLE QUESTIONNAIRE(
    ID INT NOT NULL PRIMARY KEY AUTO_INCREMENT,
    NOMQUESTIONNAIRE VARCHAR(100) NOT NULL,
    IDCREATEUR INT NOT NULL,
    FOREIGN KEY (IDCREATEUR) REFERENCES USER(ID) ON DELETE CASCADE
);

CREATE TABLE TYPEQUESTION(
    ID INT NOT NULL PRIMARY KEY,
    NOMTYPE VARCHAR(50) NOT NULL
);

CREATE TABLE QUESTION(
    ID INT NOT NULL PRIMARY KEY AUTO_INCREMENT,
    IDQUESTIONNAIRE INT NOT NULL,
    IDTYPEQUESTION INT NOT NULL,
    INTITULE VARCHAR(50) NOT NULL,
    NOMBREPOINTREUSSITE INT NOT NULL,
    NOMBREPOINTECHEC INT NOT NULL,
    FOREIGN KEY (IDQUESTIONNAIRE) REFERENCES QUESTIONNAIRE(ID) ON DELETE CASCADE,
    FOREIGN KEY (IDTYPEQUESTION) REFERENCES TYPEQUESTION(ID)
);

CREATE TABLE REPONSEQUESTION(
    ID INT NOT NULL PRIMARY KEY AUTO_INCREMENT,
    IDQUESTION INT NOT NULL,
    TEXTEREPONSE VARCHAR(50) NOT NULL,
    REPONSEVALIDE BOOLEAN NOT NULL,
    FOREIGN KEY (IDQUESTION) REFERENCES QUESTION(ID) ON DELETE CASCADE
);

CREATE TABLE REPONSEUSER(
    IDUSER INT NOT NULL,
    IDQUESTIONNAIRE INT NOT NULL,
    NUMEROESSAI INT NOT NULL,
    PRIMARY KEY (IDUSER, IDQUESTIONNAIRE),
    FOREIGN KEY (IDUSER) REFERENCES USER(ID) ON DELETE CASCADE,
    FOREIGN KEY (IDQUESTIONNAIRE) REFERENCES QUESTIONNAIRE(ID) ON DELETE CASCADE
);

INSERT INTO TYPEQUESTION VALUES (1, 'QCM');
INSERT INTO TYPEQUESTION VALUES (2, 'QCU');
